;Field Draw Subroutines
;------------------------------------------------------
;$Id: fielddraw.s,v 1.2.4.6 2002/08/16 04:14:11 Billy Exp $
;------------------------------------------------------
;fieldraw - 
;	only used in this routine:
;		outercnt	- the number of rows of blocks to draw, is set OUTSIDE the 
;						subroutine, but only used in the sub
;		
;	used in other parts of the kernel:
;		leftpf2  	- "video memory"	
;		rightpf2
;draw the playfield
;one blank line followed by 6 drawn lines
;outercnt must be set up outside the subroutine to tell it how many lines to draw

playerfielddraw	subroutine	
	lda	#$fc
	sta	PF0
	sta	PF1

;	lda	#BACKGROUND
;	sta	WSYNC
;	sta	COLUBK
;	ldy	#5
;	jsr wait_lines
;	lda	#BLACK
;	sta	WSYNC
;	sta COLUBK
;	lda	#BACKGROUND
;	sta	WSYNC
;	sta	COLUBK
;	ldy	#5
;	jsr wait_lines
	
	sta	WSYNC
.outer_draw
;------------------------------------
	lda	#BLACK
	sta COLUBK
	sta COLUPF

	lda #2				;inner draw loop length is 6
	sta	innercnt

	ldx	outercnt		;load the linecnt into x
	
.inner_draw
	lda	#BACKGROUND
	sta WSYNC		;3
	sta	COLUBK		;3
	
	lda	leftp0,x 	;4
	sta	PF2			;3

	ldy	#4
.delay0
	dey
	bne	.delay0

	lda	#P0COLOR
	sta	COLUPF+$100
	nop
	nop
			
	lda	rightp0,x	;4
	sta	PF2			;3 store the graphics for the right side of the screen				
	
	nop
	nop
	nop
	nop
		
	lda	#BLACK
	sta	COLUPF
	
	sta	WSYNC		;wait for the sync

	lda	leftp1,x	
	sta	PF2
	
	ldy	#4
.delay1
	dey
	bne	.delay1
	nop
	nop

	lda	#P1COLOR	
	sta	COLUPF

	nop					
	nop
	
	lda	rightp1,x
	sta	PF2			;store the graphics for the right side of the screen

	nop
	nop
	nop
	nop
		
	lda	#BLACK
	sta	COLUPF

	sta	WSYNC		;wait for the sync

	lda	leftpf,x	
	sta	PF2
	
	ldy	#4
.delaypf
	dey
	bne	.delaypf
	nop
	nop

	lda	#BLANKCOLOR	
	sta	COLUPF

	nop					
	nop
	
	lda	rightpf,x
	sta	PF2			;store the graphics for the right side of the screen

	nop
	nop
	nop
	nop
		
	lda	#BLACK
	sta	COLUPF
		
	dec innercnt
	bne .inner_draw
	
	lda	#0
	sta WSYNC	
	sta COLUBK
	sta	PF2

	
	dec	outercnt		;count  down to 0
	bpl .outer_draw		

	rts
;------------------------------------
fielddrawpf	subroutine	

.outer_draw
;------------------------------------
	lda #3				;inner draw loop length is 6
	sta	innercnt

	ldx	outercnt		;load the linecnt into x
	
.inner_draw
	sta	WSYNC		;wait for the sync
	lda	#BLANKCOLOR
	sta	COLUPF+$100
	lda	leftpf,x	
	sta	PF2
	
	ldy	#5
.delay0
	dey
	bne	.delay0		
	nop
				
	lda	rightpf,x

	sta	PF2			;store the graphics for the right side of the screen

	sta	WSYNC		;wait for the sync
	lda	#BLANKCOLOR
	sta	COLUPF+$100
	lda	leftpf,x	
	sta	PF2
	
	ldy	#5
.delay1
	dey
	bne	.delay1
	nop
				
	lda	rightpf,x

	sta	PF2			;store the graphics for the right side of the screen

	dec innercnt
	bne .inner_draw

	sta WSYNC
	lda	#0

	sta	PF2

	dec	outercnt		;count  down to 0
	bpl .outer_draw		

	rts
;-----------
fielddrawp0	subroutine	

.outer_draw
;------------------------------------
	lda #6				;inner draw loop length is 6
	sta	innercnt

	ldx	outercnt		;load the linecnt into x
	
.inner_draw
	sta	WSYNC		;wait for the sync
	lda	#P0COLOR
	sta	COLUPF+$100
	lda	leftp0,x	
	sta	PF2
	
	ldy	#5
.delay0
	dey
	bne	.delay0		
	nop
				
	lda	rightp0,x

	sta	PF2			;store the graphics for the right side of the screen

	dec innercnt
	bne .inner_draw

	sta WSYNC
	lda	#0

	sta	PF2

	dec	outercnt		;count  down to 0
	bpl .outer_draw		

	rts

;******************88
fielddrawp1	subroutine	

.outer_draw
;------------------------------------
	lda #6				;inner draw loop length is 6
	sta	innercnt

	ldx	outercnt		;load the linecnt into x
	
.inner_draw
	sta	WSYNC		;wait for the sync
	lda	#P1COLOR
	sta	COLUPF+$100
	lda	leftp1,x	
	sta	PF2
	
	ldy	#5
.delay0
	dey
	bne	.delay0		
	nop
				
	lda	rightp1,x

	sta	PF2			;store the graphics for the right side of the screen

	dec innercnt
	bne .inner_draw

	sta WSYNC
	lda	#0

	sta	PF2

	dec	outercnt		;count  down to 0
	bpl .outer_draw		

	rts

;************************************************************************
;clear the whole playfield

clear_playfield 	subroutine
	lda	#0
	ldx	#32
.loop
	sta	leftpf,x
	dex
	bpl .loop
	rts
;************************************************************************
;************************************************************************
;sets up a stock playfield
;arguments:
;A	- is set to the playfield number

load_playfield subroutine
	ldx	#31
.load_playfield_loop	
	lda	Start0,x
	sta	leftp0,x
	lda	Start1,x
	sta	leftp1,x
	lda	StartPF,x
	sta	leftpf,x
	dex
	bpl .load_playfield_loop

	rts
	
;------------------------------------------------------
;$Log: fielddraw.s,v $
;Revision 1.2.4.6  2002/08/16 04:14:11  Billy
;maybe interlacing works.
;
;Revision 1.2.4.5  2002/08/16 02:38:45  Billy
;submitted to stella list, ugly
;
;Revision 1.2.4.4  2002/08/14 03:26:32  Billy
;tiles working, pattern2
;
;Revision 1.2.4.3  2002/08/14 03:18:39  Billy
;tiles working, pattern1
;
;Revision 1.2.4.2  2002/08/14 02:25:56  Billy
;experiment with changing background color
;
;Revision 1.2.4.1  2002/08/14 01:11:49  Billy
;Playfield experiments
;
;Revision 1.2  2002/07/09 03:32:10  Billy
;first pass, bare kernel working
;
;Revision 1.1.1.1  2002/07/08 23:59:11  Billy
;WW Kernel Start
;
;------------------------------------------------------
